[tox]
envlist =
    py{36,37,38,39,310}
    clean
    cov
    docs
    fmt
    lint

[testenv]
deps =
    .[test]
commands =
    pytest {posargs}

[testenv:build]
basepython = python3.8
deps =
    twine
    wheel
commands =
    python setup.py sdist bdist_wheel
    twine check dist/*.whl dist/*.tar.gz
    python setup.py clean --all

[testenv:clean]
skip_install = true
deps =
    cleanpy>=0.3
commands =
    cleanpy --force --all --exclude-envs .

[testenv:cov]
deps =
    .[test]
    coverage[toml]>=5
commands =
    coverage run -m pytest {posargs:-vv}
    coverage report -m

[testenv:docs]
basepython = python3.8
deps =
    -r{toxinidir}/requirements/docs_requirements.txt
commands =
    python setup.py build_sphinx --source-dir=docs/ --build-dir=docs/_build --all-files

[testenv:fmt]
basepython = python3.8
skip_install = true
deps =
    autoflake
    black
    isort>=5
commands =
    autoflake --in-place --recursive --remove-all-unused-imports --ignore-init-module-imports .
    isort .
    black setup.py docs/ datetimerange/ examples/ test/

[testenv:lint]
basepython = python3.8
skip_install = true
deps =
    codespell
    mypy>=0.902
    pylama
    types-python-dateutil
commands =
    python setup.py check
    mypy datetimerange/ setup.py
    -codespell -q2 --check-filenames docs/pages datetimerange/ examples/ test/ README.rst
    pylama

[testenv:readme]
skip_install = true
changedir = docs
deps =
    path
    readmemaker>=1.0.0
commands =
    python make_readme.py
